/*\
 *  Effects.Rexx
 *   Several new effects to add to your collection.
 *
 *   Written By: Ian Smith / 27 Gibson St / North East, PA 16428
 *               Usenet: IanSmith@moose.erie.net
 *               Usenet backup: IanSmith@psu.edu
 *               Web: http://moose.erie.net/~iansmith/
 *               Digital Matrix BBS (814) 825-3783 FIDO: 1:2601/564.0
 *
\*/

If ~Show('L',"rexxsupport.library") Then
 If ~AddLib("rexxsupport.library",0,-30,0) Then
  Error('Can not find "rexxsupport.library"!')

CmdPath="CMPI:"
CmdName="Effects"
If Exists("CMPI:"CmdName) Then        /* This should find the executable */
 CmdPath="CMPI:"CmdName               /* no matter where its hiding!     */
Else If Exists("C:"CmdName) Then
 CmdPath="C:"CmdName
Else If Exists("REXX:"CmdName) Then
 CmdPath="REXX:"CmdName
Else If Exists("RXPI:"CmdName) Then
 CmdPath="RXPI:"CmdName
Else If Exists("Rexx:picmdpath") Then
 If Open(In,"Rexx:picmdpath","R") Then Do
  CmdPath=ReadLn(In)||CmdName
  Call Close(In)
 End
If ~Exists(CmdPath) Then
 DispError("I can't find the Effects executable!")

Options Results
Address("IM_Port")
'current'
Parse Var Result BufferName ',' BufferNum ',' XSize ',' YSize ',' .

'gadgets "Random","Colors","Single","Primary","Dynamic","Pixels","Clip Image","Bitplanes","Total","Colors","Pixelize","Image","Pixelize","Chroma","Pixelize","Luma","Brightness","UnFocus","Neon","Edging","Delta","Pixelize","Scramble","Pixels","Count","Colors"'
Type=Result

Args=Type
If Type=0 Then
 Exit
If Type=1 Then Do
 TempVar=GetClip('Effects_RAM_Storage_RanCol')
 If TempVar="" Then
  TempVar="1 1"
 Parse Var TempVar XSav YSav
 If XSav<1 || XSav>XSize Then
  XSav=1
 If YSav<1 || YSav>YSize Then
  YSav=1
 'askprop "Number of horizontal squares: " 'XSav' 1' XSize
 XSav=Result
 XSize=XSize/XSav
 'askprop "Number of vertical squares: " 'YSav' 1' YSize
 YSav=Result
 YSize=YSize/YSav
 Args=1 XSize YSize
 Call SetClip('Effects_RAM_Storage_RanCol', XSav YSav)
End
If Type=3 Then Do
 TempVar=GetClip('Effects_RAM_Storage_DyPix')
 If TempVar="" Then
  TempVar="255 0"
 Parse Var TempVar Hot Cold
 If Hot<0 || Hot>255 Then
  Hot=255
 If Cold<0 || Cold>255 Then
  Cold=0
 'askprop "Hot level: " 'Hot' 0 255'
  Hot=Result
 'askprop "(Hot='Hot') Cold level: " 'Cold' 0 255'
 Cold=Result
 Args=3 Hot Cold
 Call SetClip('Effects_RAM_Storage_DyPix', Hot" "Cold)
End
If Type=4 Then Do
 Bits=GetClip('Effects_RAM_Storage_ClpBts')
 If Bits="" Then
  Bits=8
 If Bits<1 || Bits>8 Then
  Bits=8
 'gadgets "Clip","All","Clip","Red","Clip","Blue","Clip","Green"'
 GRGB=Result
 If GRGB=0 Then
  Exit
 'askprop "Bits:" 'Bits' 1 8'
 Bits=Result
 If GRGB=1 Then
  Args=4 Bits Bits Bits
 If GRGB=2 Then
  Args=4 Bits 8 8
 If GRGB=3 Then
  Arga=4 8 Bits 8
 If GRGB=4 Then
  Args=4 8 8 Bits
 Call SetClip('Effects_RAM_Storage_ClpBts')
End
If Type=6 Then Do
 TempVar=GetClip('Effects_RAM_Storage_Pixel')
 If TempVar="" Then
  TempVar="1 1"
 Parse Var TempVar Horz Vert
 If Horz<1 || Horz>XSize Then
  Horz=1
 If Vert<1 || Vert>YSize Then
  Vert=1
 'askprop "Number of horizontal squares: " 'Horz' 1' XSize
 Horz=Result
 XSize=XSize/Horz
 'askprop "Number of vertical squares: " 'Vert' 1' YSize
 Vert=Result
 YSize=YSize/Vert
 Args=6 XSize YSize
 Call SetClip('Effects_RAM_Storage_Pixel', Horz" "Vert)
End
If Type=7 Then Do
 TempVar=GetClip('Effects_RAM_Storage_PixChr')
 If TempVar="" Then
  TempVar="1 1"
 Parse Var TempVar Horz Vert
 If Horz<1 || Horz>XSize Then
  Horz=1
 If Vert<1 || Vert>YSize Then
  Vert=1
 'askprop "Number of horizontal squares: " 'Horz' 1' XSize
 Horz=Result
 XSize=XSize/Horz
 'askprop "Number of vertical squares: " 'Vert' 1' YSize
 Vert=Result
 YSize=YSize/Vert
 Args=7 XSize YSize
 Call SetClip('Effects_RAM_Storage_PixChr', Horz" "Vert)
End
If Type=8 Then Do
 TempVar=GetClip('Effects_RAM_Storage_PixLum')
 If TempVar="" Then
  TempVar="1 1"
 Parse Var TempVar Horz Vert
 If Horz<1 || Horz>XSize Then
  Horz=1
 If Vert<1 || Vert>YSize Then
  Vert=1
 'askprop "Number of horizontal squares: " 'Horz' 1' XSize
 Horz=Result
 XSize=XSize/Horz
 'askprop "Number of vertical squares: " 'Vert' 1' YSize
 Vert=Result
 YSize=YSize/Vert
 Args=8 XSize YSize
 Call SetClip('Effects_RAM_Storage_PixLum', Horz" "Vert)
End
If Type=9 Then Do
 TempVar=GetClip('Effects_RAM_Storage_PixBri')
 If TempVar="" Then
  TempVar="3 3 85"
 Parse Var TempVar Horz Vert Percent
 If Horz>49 Then
  Horz=49
 If Vert>49 Then
  Vert=49
 If Percent>100 | Percent<1 Then
  Percent=100
 'askprop "X Matrix Size (Odd Only): "' Horz '1 49'
 Horz=Result
 'askprop "Y Matrix Size (Odd Only): "' Vert '1 49'
 Vert=Result
 'askprop "Percent of effect: "' Percent '1 100'
 Percent=Result
 Args=10 Horz Vert Percent
 Call SetClip('Effects_RAM_Storage_PixBri', Horz" "Vert" "Percent)
End
If Type=10 Then Do
 TempVar=GetClip('Effects_RAM_Storage_NeonEdg')
 If TempVar="" Then
  TempVar="3 3"
 Parse Var TempVar Horz Vert
 If Horz>49 Then
  Horz=49
 If Vert>49 Then
  Vert=49
 'askprop "X Matrix Size (Odd Only): "' Horz '1 49'
 Horz=Result
 'askprop "Y Matrix Size (Odd Only): "' Vert '1 49'
 Vert=Result
 Args=11 Horz Vert
 Call SetClip('Effects_RAM_Storage_NeonEdg', Horz" "Vert)
End
If Type=11 Then Do
 TempVar=GetClip('Effects_RAM_Storage_PixDelt')
 If TempVar="" Then
  TempVar="1 1"
 Parse Var TempVar Horz Vert
 If Horz<1 || Horz>XSize Then
  Horz=1
 If Vert<1 || Vert>YSize Then
  Vert=1
 'askprop "Number of horizontal squares: " 'Horz' 1' XSize
 Horz=Result
 XSize=XSize/Horz
 'askprop "Number of vertical squares: " 'Vert' 1' YSize
 Vert=Result
 YSize=YSize/Vert
 Args=12 XSize YSize
 Call SetClip('Effects_RAM_Storage_PixDelt', Horz" "Vert)
End
If Type=12 Then Do
 TempVar=GetClip('Effects_RAM_Storage_Scramble')
 If TempVar="" Then
  TempVar="2 2 50"
 Parse Var TempVar XDist YDist Effect
 If XDist>XSize Then
  XDist=XSize
 If YDist>YSize Then
  YDist=YSize
 'askprop "X Pixel Travel: "' XDist '1' XSize
 XDist=Result
 'askprop "Y Pixel Travel: "' YDist '1' YSize
 YDist=Result
 'askprop "Effect % "' Effect '1 100'
 Effect=Result
 Args=13 XDist YDist Effect
 Call SetClip('Effects_RAM_Storage_Scramble', XDist" "YDist" "Effect)
End
If Type=13 Then Do
 'gadgets "2048K","1 Pass","1024K","2 Pass","512K","4 Pass","256K","8 Pass","128K","16 Pass","64K","32 Pass","32K","64 Pass","16K", "128 Pass","8K","256 Pass"'
 Passes=Result
 If Passes=0 Then
  Exit
 Passes=2**(Passes-1)
 Args=14 Passes
End

Address("IM_Port")
'jackin'
jacker = Result
If (Type ~= 5) & (Type ~= 13) Then Do
 'backuptoundo'
 Address Command CmdPath Jacker Args
 'redraw'
End; Else Do
 TmpFile="RAM:Effects_Temp$"||Time(S)||"$"
 Say Address Command CmdPath Jacker Args
 Address Command CmdPath Jacker Args ">"||TmpFile
 Call Open(In, TmpFile, "R")
  Line=ReadLN(In)
  'message' Line
 Call Close(In)
 Address Command 'Delete QUIET' TmpFile
End
Exit 0

DispError:
 Parse Arg Message
 Address("IM_Port")
 'message "'Message'"'
 Exit 10
Return
